package Scream.Markup.Author is
	
	type Block is new Markup.Block with record
		Link : Ada.Strings.Unbounded.Unbounded_String;
		Items : aliased Inline_Access;
	end record;
	
	overriding procedure Iterate (
		Item : in Block;
		Process : not null access procedure (Item : in Element'Class));
	
	type Mark is new Markup.Mark with null record;
	
	overriding procedure Parse_Block (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Block_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean);
	
	overriding function Create (Params : not null access Params_Type)
		return Mark;
	
end Scream.Markup.Author;
