package body Scream.Markup.Delete is
	
	type Inline_Access is access Inline;
	type Block_Access is access Block;
	
	overriding procedure Iterate (
		Item : in Inline;
		Process : not null access procedure (Item : in Element'Class)) is
	begin
		Iterate (Item.Items, Process);
	end Iterate;
	
	overriding procedure Iterate (
		Item : in Block;
		Process : not null access procedure (Item : in Element'Class)) is
	begin
		Iterate (Item.Items, Process);
	end Iterate;
	
	overriding procedure Parse_Inline (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Inline_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean)
	is
		New_Item : not null Inline_Access :=
			new Inline'(Markup.Inline with Items => null);
	begin
		Append (Parsing, Previous, New_Item);
		Parse_Inline (
			Parsing,
			New_Item.Items'Unchecked_Access,
			Source,
			Position,
			New_Item.Contents,
			Stopper);
	end Parse_Inline;
	
	overriding procedure Parse_Block (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Block_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean)
	is
		New_Item : not null Block_Access :=
			new Block'(Markup.Block with Items => null);
	begin
		Append (Parsing, Previous, New_Item);
		Parse_Block (
			Parsing,
			New_Item.Items'Unchecked_Access,
			Source,
			Position,
			New_Item.Contents,
			Stopper);
	end Parse_Block;
	
	overriding function Create (Params : not null access Params_Type)
		return Mark is
	begin
		return (null record);
	end Create;
	
begin
	Register ("DELETE", Mark'Tag);
	Register ("DEL", Mark'Tag);
end Scream.Markup.Delete;
