package Scream.Markup.Emphasis is
	
	type Style is (
		Big,
		Bold,
		Cite,
		Definition,
		Emphasis,
		Italic,
		Mark,
		Small,
		Strong,
		Sub,
		Sup,
		Variable);
	
	type Style_Set is array (Style) of Natural;
	
	type Block is new Markup.Block with record
		Style : Style_Set;
		Items : aliased Inline_Access;
	end record;
	
	type Inline is new Markup.Inline with record
		Style : Style_Set;
		Items : aliased Inline_Access;
	end record;
	
	overriding procedure Iterate (
		Item : in Inline;
		Process : not null access procedure (Item : in Element'Class));
	
	type Mark_Type is new Markup.Mark with record
		Style : Markup.Emphasis.Style;
	end record;
	
	overriding procedure Parse_Block (
		The_Mark : in Mark_Type;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Block_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean);
	
	overriding procedure Parse_Inline (
		The_Mark : in Mark_Type;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Inline_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean);
	
	overriding function Create (Params : not null access Params_Type)
		return Mark_Type;
	
end Scream.Markup.Emphasis;
