package body Scream.Markup.History is
	
	type Block_Access is access Block;
	
	overriding procedure Parse_Block (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Block_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean)
	is
		New_Item : not null Block_Access := new Block'(Markup.Block with null record);
		Contents_First : Positive := Position.Index;
		Contents_Last : Natural := Position.Index - 1;
		Last : Natural;
	begin
		Append (Parsing, Previous, New_Item);
		while not Stopper (Source (Position.Index .. Source'Last)) loop
			Take_Line (Source, Last, Position);
			Contents_Last := Last;
		end loop;
		Append (Parsing, New_Item.Contents, Source (Contents_First .. Contents_Last));
	end Parse_Block;
	
	overriding function Create (Params : not null access Params_Type)
		return Mark is
	begin
		return (null record);
	end Create;
	
begin
	Register ("HISTORY", Mark'Tag);
end Scream.Markup.History;
