package body Scream.Markup.Http is
	
	type Inline_Access is access Inline;
	
	overriding procedure Iterate (
		Item : in Inline;
		Process : not null access procedure (Item : in Element'Class)) is
	begin
		Iterate (Item.Items, Process);
	end Iterate;
	
	overriding procedure Parse_Inline (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Inline_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean)
	is
		New_Item : not null Inline_Access :=
			new Inline'(
				Markup.Inline
					with
						Scheme => The_Mark.Scheme,
						Link => Ada.Strings.Unbounded.To_Unbounded_String (Argument),
						Items => null);
	begin
		Append (Parsing, Previous, New_Item);
		Parse_Inline (
			Parsing,
			New_Item.Items'Unchecked_Access,
			Source,
			Position,
			New_Item.Contents,
			Stopper);
	end Parse_Inline;
	
	overriding function Create (Params : not null access Params_Type)
		return Mark is
	begin
		return (Scheme => Scheme'Val (Params.Data));
	end Create;
	
begin
	for I in Scheme loop
		Register (Scheme'Image (I), Mark'Tag, (Data => Scheme'Pos (I)));
	end loop;
end Scream.Markup.Http;
