package Scream.Markup.Http is
	
	type Scheme is (HTTP, HTTPS);
	
	type Inline is new Markup.Inline with record
		Scheme : Markup.Http.Scheme;
		Link : Ada.Strings.Unbounded.Unbounded_String;
		Items : aliased Inline_Access;
	end record;
	
	overriding procedure Iterate (
		Item : in Inline;
		Process : not null access procedure (Item : in Element'Class));
	
	type Mark is new Markup.Mark with record
		Scheme : Markup.Http.Scheme;
	end record;
	
	overriding procedure Parse_Inline (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Inline_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean);
	
	overriding function Create (Params : not null access Params_Type)
		return Mark;
	
end Scream.Markup.Http;
