with Scream.Pages;
package body Scream.Markup.Include is
	
	type Inline_Access is access Inline;
	type Block_Access is access Block;
	
	overriding procedure Parse_Inline (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Inline_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean)
	is
		New_Item : not null Inline_Access :=
			new Inline'(
				Markup.Inline
					with Path =>
						Ada.Strings.Unbounded.To_Unbounded_String (Argument));
		Contents_First : Positive := Position.Index;
		Contents_Last : Natural := Position.Index - 1;
	begin
		Scream.Pages.Page_Sets.Include (Parsing.Reference.all, Argument);
		Append (Parsing, Previous, New_Item);
		while not Stopper (Source (Position.Index .. Source'Last)) loop
			Contents_Last := Position.Index;
			Next (Source, Position);
		end loop;
		Append (Parsing, New_Item.Contents, Source (Contents_First .. Contents_Last));
	end Parse_Inline;
	
	overriding procedure Parse_Block (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Block_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean)
	is
		New_Item : not null Block_Access :=
			new Block'(
				Markup.Block
					with Path =>
						Ada.Strings.Unbounded.To_Unbounded_String (Argument));
		Contents_First : Positive := Position.Index;
		Contents_Last : Natural := Position.Index - 1;
		Last : Natural;
	begin
		Scream.Pages.Page_Sets.Include (Parsing.Reference.all, Argument);
		Append (Parsing, Previous, New_Item);
		while not Stopper (Source (Position.Index .. Source'Last)) loop
			Take_Line (Source, Last, Position);
			Contents_Last := Last;
		end loop;
		Append (Parsing, New_Item.Contents, Source (Contents_First .. Contents_Last));
	end Parse_Block;
	
	overriding function Create (Params : not null access Params_Type)
		return Mark is
	begin
		return (null record);
	end Create;
	
begin
	Register ("INCLUDE", Mark'Tag);
end Scream.Markup.Include;
