package Scream.Markup.Include is
	
	type Inline is new Markup.Inline with record
		Path : Ada.Strings.Unbounded.Unbounded_String;
	end record;
	
	type Block is new Markup.Block with record
		Path : Ada.Strings.Unbounded.Unbounded_String;
	end record;
	
	type Mark is new Markup.Mark with null record;
	
	overriding procedure Parse_Inline (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Inline_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean);
	
	overriding procedure Parse_Block (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Block_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean);
	
	overriding function Create (Params : not null access Params_Type)
		return Mark;
	
end Scream.Markup.Include;
