with Ada.Strings.Fixed;
package body Scream.Markup.Section is
	
	type Block_Access is access Block;
	
	overriding procedure Iterate (
		Item : in Block;
		Process : not null access procedure (Item : in Element'Class)) is
	begin
		Iterate (Item.Items, Process);
	end Iterate;
	
	overriding procedure Parse_Block (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Block_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean)
	is
		New_Item : not null Block_Access :=
			new Block'(
				Markup.Block
					with
						Label => Ada.Strings.Unbounded.Null_Unbounded_String,
						Title => Ada.Strings.Unbounded.Null_Unbounded_String,
						Items => null);
		Title_First : Positive;
		Colon : Natural := Ada.Strings.Fixed.Index (Argument, ":");
	begin
		if Colon > 0 then
			New_Item.Label := Ada.Strings.Unbounded.To_Unbounded_String (
				Ada.Strings.Fixed.Trim (
					Argument (Argument'First .. Colon - 1),
					Side => Ada.Strings.Both));
			Title_First := Colon + 1;
		else
			Title_First := Argument'First;
		end if;
		New_Item.Title := Ada.Strings.Unbounded.To_Unbounded_String (
			Ada.Strings.Fixed.Trim (
				Argument (Title_First .. Argument'Last),
				Side => Ada.Strings.Both));
		Append (Parsing, Previous, New_Item);
		Parse_Block (
			Parsing,
			New_Item.Items'Unchecked_Access,
			Source,
			Position,
			New_Item.Contents,
			Stopper);
	end Parse_Block;
	
	overriding function Create (Params : not null access Params_Type)
		return Mark is
	begin
		return (null record);
	end Create;
	
begin
	Register ("SECTION", Mark'Tag);
end Scream.Markup.Section;
