package body Scream.Markup.Table is
	
	type Block_Access is access Block;
	
	overriding procedure Iterate (
		Item : in Block;
		Process : not null access procedure (Item : in Element'Class))
	is
		I : Lists.Cursor := Item.Items.First;
	begin
		while Lists.Has_Element (I) loop
			Iterate (Item.Items.Constant_Reference (I).Items, Process);
			Lists.Next (I);
		end loop;
	end Iterate;
	
	overriding procedure Parse_Block (
		The_Mark : in Mark;
		Argument : in String;
		Argument_Position : in Source_Position;
		Parsing : not null access Markup.Parsing;
		Previous : in out Block_Access_Access;
		Source : in String;
		Position : in out Source_Position;
		Stopper : not null access function (Source : String) return Boolean)
	is
		function Is_Column (S : String) return Boolean is
		begin
			return Is_End_Of_Line (S) or else S (S'First) = '|';
		end Is_Column;
		New_Item : not null Block_Access :=
			new Block'(Markup.Block with Items => Lists.Empty_List);
		First : Boolean;
	begin
		Append (Parsing, Previous, New_Item);
		while not Stopper (Source (Position.Index .. Source'Last)) loop
			if Source (Position.Index) = '|' then
				Next (Source, Position);
			end if;
			First := True;
			while not Is_End_Of_Line (Source (Position.Index .. Source'Last)) loop
				Skip_Spaces (Source, Position);
				declare
					Item : Table.Item;
				begin
					Item.First := First;
					Parse_Inline (
						Parsing,
						Item.Items'Unchecked_Access,
						Source (Position.Index .. Source'Last),
						Position,
						Item.Contents,
						Is_Column'Access);
					Lists.Append (New_Item.Items, Item);
				end;
				exit when Is_End_Of_Line (Source (Position.Index .. Source'Last));
				pragma Assert (Source (Position.Index) = '|');
				Next (Source, Position);
				First := False;
			end loop;
			Skip_Single_Line_Feed (Source, Position);
		end loop;
	end Parse_Block;
	
	overriding function Create (Params : not null access Params_Type)
		return Mark is
	begin
		return (null record);
	end Create;
	
begin
	Register ("TABLE", Mark'Tag);
end Scream.Markup.Table;
